% Vivaldo Mendes, ISCTE--IUL, December 2009
% This routine applies a cubic spline interpolation in order 
% to transform annual data into quarterly data
% 
% Suppose your annual data is in file "Hours.txt", second column
% So you have 68 observations, and you want to transform them into 4 times
% more observations (272, in total).
% This will do the trick 

load Hours.txt;
y=Hours(:,2);

x=1:4:272; % you are saying that you want to spread out your ORIGINAL OBSERVATIONS 
% along a vector from 1 up to 272, with an increment of 4 (months) 

t4=x'; % just because y (my original data) is in a column-vector, while t4 is a line-vector

xx=1:272; % This is the new vector containing all the 272 observations (the original ones, 
% and the new ones that are obtained by the inperpolation 

t12=xx'; % just because xx is a line-vector and ....

yy=spline(t4,y,t12); % this is the Cubic spline data interpolation function


plot(t4,y,'*b',t12,yy,'.r')% This makes a figure, with the original values
grid on

%represented by a "*", and the interpolated ones by a ".".

% Nice figure!? But use with care, because you are just creating artificial
% data. But, many,many very important people do a lot of this kind of
% interpolation.