% Routine to obtain a linear trend without breaks and with breaks
% To be run, it requires the function "trend.m" in the same folder.
%  Vivaldo Mendes, ISCTE, 2009

clear;
clc;

load USdata.txt;
time=1947.0:0.25:2008.5;
GDP=USdata(:,7);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Linear trend without breaks
y = trend(GDP,'linear');
figure; 
subplot(211)
plot(time',y,'b'); hold on; 
plot(time',GDP,'r');
grid on

% Plot the business cycles
subplot(212);
stem(time,GDP-y,'.')
grid on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Linear trend with breaks (breaks at observations 108, 170)

y1 = trend(GDP,'linear',[108,170]);
figure;
subplot(211)
plot(time',y1,'b'); hold on; 
plot(time(108),y1(108),'*'); 
plot(time(170),y1(170),'*');
plot(time',GDP,'r');
grid on

subplot(212);stem(time',GDP-y1,'r','.')
grid on

% FANCY EDITING
% Just individual figures as above, but with fancy editions

figure; 
plot(time',y,'b'); hold on; 
plot(time',GDP,'r');
grid on
xlabel('time (quarters)')
ylabel('Log GDP and trend')
title('Log linear detrending without breaks')


figure;
stem(time,GDP-y,'.')
grid on
xlabel('time (quarters)')
ylabel('% deviations from trend')
title('Business cycles: log linear trend without breaks')


figure;
plot(time',y1,'-b'); hold on; 
plot(time(108),y1(108),'*'); 
plot(time(170),y1(170),'*');
plot(time',GDP,'-r');
grid on
xlabel('time (quarters)')
ylabel('Log GDP and trend')
title('Log linear trend with two breaks')



figure;
stem(time',GDP-y1,'r','.')
grid on
xlabel('time (quarters)')
ylabel('% deviations from trend')
title('Business cycles: log linear detrending with two breaks')